<template>
  <div class="wait-task-flow">
    <div class="part-box part-box-pad">
      <el-table ref="TableList" :data="dataList" :height="tableHeight">
        <el-table-column
          type="index"
          label="序号"
          width="50"
          :index="indexMethod"
        ></el-table-column>
        <el-table-column
          prop="paperNumber"
          label="试卷编号"
          min-width="200"
          show-overflow-tooltip
        ></el-table-column>
        <el-table-column
          prop="type"
          label="课程（代码）"
          min-width="260"
          show-overflow-tooltip
        >
          <template slot-scope="scope">
            {{ scope.row.courseName }}（{{ scope.row.courseCode }}）
          </template>
        </el-table-column>
        <el-table-column
          prop="taskName"
          label="流程节点"
          width="120"
          show-overflow-tooltip
        >
          <span slot-scope="scope">
            {{ scope.row.taskName | flowTaskNameFilter }}
          </span>
        </el-table-column>
        <el-table-column prop="createTime" label="创建时间" width="170">
          <span slot-scope="scope">{{
            scope.row.createTime | timestampFilter
          }}</span>
        </el-table-column>
        <el-table-column
          class-name="action-column"
          label="操作"
          width="100"
          fixed="right"
        >
          <template slot-scope="scope">
            <el-button class="btn-primary" type="text" @click="toDo(scope.row)"
              >立即处理</el-button
            >
          </template>
        </el-table-column>
      </el-table>
      <div v-if="!isOnePage" class="part-page">
        <el-pagination
          background
          layout="total, prev, pager, next, jumper"
          :pager-count="5"
          :current-page="current"
          :total="total"
          :page-size="size"
          @current-change="toPage"
        >
        </el-pagination>
      </div>
    </div>

    <!-- ModifyTaskApply -->
    <modify-task-apply
      ref="ModifyTaskApply"
      :row-data="curTask"
      @modified="updateList"
    ></modify-task-apply>
  </div>
</template>

<script>
import { mapState, mapActions } from "vuex";
import { waitExamTaskListPage } from "../api";
import ModifyTaskApply from "./taskApply/ModifyTaskApply.vue";

export default {
  name: "wait-task-flow",
  components: { ModifyTaskApply },
  data() {
    return {
      current: 1,
      size: 2,
      total: 0,
      dataList: [],
      curTask: {},
    };
  },
  computed: {
    ...mapState("exam", ["waitTask"]),
    isOnePage() {
      return this.waitTask.flow <= 3;
    },
    pageSize() {
      return this.isOnePage ? 3 : 2;
    },
    tableHeight() {
      return this.isOnePage ? 174 : 127;
    },
  },
  mounted() {
    this.getList();
  },
  methods: {
    ...mapActions("exam", ["updateWaitTaskCount"]),
    async updateList() {
      await this.updateWaitTaskCount();
      await this.getList();
    },
    async getList() {
      const datas = {
        pageNumber: this.current,
        pageSize: this.pageSize,
      };
      const data = await waitExamTaskListPage(datas);
      this.dataList = data.records;
      this.total = data.total;
    },
    toPage(page) {
      this.current = page;
      this.getList();
    },
    toDo(task) {
      this.curTask = { ...task, source: "REVIEW" };
      this.$refs.ModifyTaskApply.open();
    },
  },
};
</script>
